// Env.cpp
//------------------------------------------------------------------------------

// Includes
//------------------------------------------------------------------------------
#include "Env.h"

#if defined( WIN32 ) || defined( WIN64 )
    #include <windows.h>
    #include <stdio.h>
#endif

// GetNumProcessors
//------------------------------------------------------------------------------
/*static*/ uint32_t Env::GetNumProcessors()
{
    #ifdef __APPLE__
        return 2; // TODO:MAC Correctly determine number of processors
    #elif defined( __WINDOWS__ )
        // Default to NUMBER_OF_PROCESSORS
        uint32_t numProcessors = 1;
        const uint32_t bufferSize( 32 );
        char buffer[ bufferSize ];
        DWORD ret = GetEnvironmentVariable( "NUMBER_OF_PROCESSORS", buffer, bufferSize );
        if ( ( ret > 0 ) && ( ret < bufferSize ) )
        {
            if ( sscanf_s( buffer, "%u", &numProcessors ) != 1 )
            {
                numProcessors = 1;
            }
        }

        return numProcessors;
    #else
        #error Unknown platform
    #endif
}

//------------------------------------------------------------------------------
